# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

# If you want to built with jdk15 support, give rpmbuild option '--with jdk15'
%define with_jdk15 %{?_with_jdk15:1}%{!?_with_jdk15:0}
%define without_jdk15 %{!?_with_jdk15:1}%{?_with_jdk15:0}

%define section  free

Summary:        JBoss Aspects Library
Name:           jboss-aspects
Version:        1.3
Release:        1jpp
Epoch:          0
License:        LGPL
Group:          Internet/WWW/Servers
Vendor:         JPackage Project
Distribution:   JPackage
URL:            http://www.jboss.org/
Source0:        jboss-aspects-1.3-src.tar.gz
# cvs -d:pserver:anonymous@anoncvs.forge.jboss.com:/cvsroot/jboss export -r JBOSS_AOP_1_3_6 jboss-aspects

Source1:	jboss-aspects-1.3-buildmagic-autoload.properties
Source2:	jboss-aspects-1.3-buildmagic-buildmagic.ent
Source4:	jboss-aspects-1.3-buildmagic-common.properties
Source5:	jboss-aspects-1.3-buildmagic-common.xml
Source6:	jboss-aspects-1.3-buildmagic-libraries.ent
Source7:	jboss-aspects-1.3-buildmagic-modules.ent
Source8:	jboss-aspects-1.3-buildmagic-targets.ent
Source9:	jboss-aspects-1.3-buildmagic-task.properties
Patch0:		jboss-aspects-1.3-build_xml.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:      noarch
# general requires
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:       ant >= 0:1.6.2
BuildRequires:       jboss4-buildmagic-tasks
BuildRequires:       junit
%if %{with_jdk15}
BuildRequires:       java-1.5.0-devel
%else
BuildRequires:       java-1.4.2-devel
%endif
BuildRequires:       bsh
BuildRequires:       concurrent
BuildRequires:       dom4j
BuildRequires:       gnu.trove
BuildRequires:       jakarta-commons-logging
BuildRequires:       javassist >= 0:3.1
BuildRequires:       jboss4-common
BuildRequires:       qdox >= 0:1.5
BuildRequires:       xdoclet
BuildRequires:       jboss4-jmx
BuildRequires:       jboss4-system
BuildRequires:       jboss4-j2ee
BuildRequires:       jboss4-transaction
BuildRequires:       jboss4-cluster
BuildRequires:       jboss-aop >= 0:1.3
BuildRequires:       jboss-remoting >= 0:1.4.1
BuildRequires:       jboss4-security
BuildRequires:       jboss4-server
Requires:       bsh
Requires:       concurrent
Requires:       dom4j
Requires:       gnu.trove
Requires:       jakarta-commons-logging
Requires:       javassist >= 0:3.1
Requires:       jboss4-common
Requires:       qdox >= 0:1.5
Requires:       xdoclet
Requires:       jboss4-jmx
Requires:       jboss4-system
Requires:       jboss4-j2ee
Requires:       jboss4-transaction
Requires:       jboss4-cluster
Requires:       jboss-aop >= 0:1.3
Requires:       jboss-remoting >= 0:1.4.1
Requires:       jboss4-security
Requires:       jboss4-server

Provides:            jboss-aop-library
Obsoletes:           jboss-aop-library

%description
JBoss AOP is not only a framework, but also a prepackaged
set of aspects that are applied via annotations, pointcut
expressions, or dynamically at runtime. Some of these
include caching, asynchronous communication, transactions,
security, remoting, and many many more.


%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
BuildRequires:  java-javadoc

%description    javadoc
%{summary}.

%prep
%setup -qq -n jboss-aspects-%{version}-src
for f in $(find . -name "*.jar"); do
	mv $f $f.no
done
mkdir -p tools/lib
pushd tools/lib
ln -sf $(build-classpath jboss4/jboss4-buildmagic-tasks) buildmagic-tasks.jar
popd
mkdir -p aop/output/lib
pushd aop/output/lib
ln -sf $(build-classpath jboss-aop/jboss-aop) .
ln -sf $(build-classpath jboss-aop/jdk14-pluggable-instrumentor) .
popd
mkdir -p cluster/output/lib
pushd cluster/output/lib
ln -sf $(build-classpath jboss4/jbossha) .
#    <pathelement path="${jboss.cluster.lib}/jbossha.jar"/>
#    <pathelement path="${jboss.cluster.lib}/jbossha-httpsession.sar"/>
#    <pathelement path="${jboss.cluster.lib}/jbossha-singleton.jar"/>
popd
mkdir -p common/output/lib
pushd common/output/lib
ln -sf $(build-classpath jboss4/jboss-common) .
popd
mkdir -p common/output/classes
pushd common/output/classes
jar xf ../lib/jboss-common.jar
popd
mkdir -p j2ee/output/lib
pushd j2ee/output/lib
ln -sf $(build-classpath jboss4/jboss-j2ee) .
popd
mkdir -p jmx/output/lib
pushd jmx/output/lib
ln -sf $(build-classpath jboss4/jboss-jmx) .
popd
mkdir -p remoting/output/lib
pushd remoting/output/lib
ln -sf $(build-classpath jboss-remoting) .
popd
mkdir -p security/output/lib
pushd security/output/lib
ln -sf $(build-classpath jboss4/jbosssx) .
#   <pathelement path="${jboss.security.lib}/jbosssx.jar"/>
#   <pathelement path="${jboss.security.lib}/jboss-jaas.jar"/>
popd
mkdir -p server/output/lib
pushd server/output/lib
ln -sf $(build-classpath jboss4/jboss) .
ln -sf $(build-classpath jboss4/jmx-adaptor-plugin) .
popd
mkdir -p system/output/lib
pushd system/output/lib
ln -sf $(build-classpath jboss4/jboss-system) .
popd
mkdir -p transaction/output/lib
pushd transaction/output/lib
ln -sf $(build-classpath jboss4/jboss-transaction) .
popd
mkdir thirdparty
pushd thirdparty
mkdir -p ant/lib
pushd ant/lib
ln -sf $(build-classpath ant) .
popd
mkdir -p beanshell/lib
pushd beanshell/lib
ln -sf $(build-classpath bsh) .
popd
mkdir -p commons/lib
pushd commons/lib
ln -sf $(build-classpath commons-logging) .
popd
mkdir -p concurrent/lib
pushd concurrent/lib
ln -sf $(build-classpath concurrent) .
popd
mkdir -p dom4j/lib
pushd dom4j/lib
ln -sf $(build-classpath dom4j) .
popd
mkdir -p javassist/lib
pushd javassist/lib
ln -sf $(build-classpath javassist) .
popd
mkdir -p junit/lib
pushd junit/lib
ln -sf $(build-classpath junit) .
popd
mkdir -p log4j/lib
pushd log4j/lib
ln -sf $(build-classpath log4j) .
popd
mkdir -p qdox/lib
pushd qdox/lib
ln -sf $(build-classpath qdox) .
popd
mkdir -p trove/lib
pushd trove/lib
ln -sf $(build-classpath gnu.trove) trove.jar
popd
mkdir -p xdoclet/lib
pushd xdoclet/lib
ln -sf $(build-classpath xdoclet/xdoclet) .
popd
popd

mkdir -p tools/etc/buildmagic
cp %{SOURCE1} tools/etc/buildmagic/autoload.properties
cp %{SOURCE2} tools/etc/buildmagic/buildmagic.ent
cp %{SOURCE4} tools/etc/buildmagic/common.properties
cp %{SOURCE5} tools/etc/buildmagic/common.xml
cp %{SOURCE6} thirdparty/libraries.ent
cp %{SOURCE7} tools/etc/buildmagic/modules.ent
cp %{SOURCE8} tools/etc/buildmagic/targets.ent
cp %{SOURCE9} tools/etc/buildmagic/task.properties

%patch0 -b .sav

%build

BUILD_ID=`date -u +%Y%m%d%H%M`_%{version}-%{release}

%if %{with_jdk15}
export JAVA_HOME=/usr/lib/jvm/java-1.5.0
%else
export JAVA_HOME=/usr/lib/jvm/java-1.4.2
%endif
export CLASSPATH=""

ant all


%install
rm -rf $RPM_BUILD_ROOT

install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}

# install aspect library
install -m 644 output/lib/jboss-aspect-library.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-aspect-library-%{version}.jar
install -m 644 output/lib/jboss-aspect-library32.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-aspect-library32-%{version}.jar
%if %{with_jdk15}
install -m 644 output/lib/jboss-aspect-library-jdk50.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-aspect-library-jdk50-%{version}.jar
install -m 644 output/lib/jboss-aspect-library-jdk50-jb32.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss-aspect-library-jdk50-jb32-%{version}.jar
%endif


# create all versionless symlinks
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)


# package home
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-32-install
pushd $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-32-install
ln -sf %{_javadir}/gnu.trove.jar trove.jar
ln -sf %{_javadir}/javassist.jar javassist.jar
ln -sf %{_javadir}/jboss-aop/jboss-aop.jar jboss-aop.jar
ln -sf %{_javadir}/jboss-aop/jboss-aspect-library32.jar jboss-aspect-library32.jar
popd
%if %{with_jdk15}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-32-install-jdk5
pushd $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-32-install-jdk5
ln -sf %{_javadir}/gnu.trove.jar trove.jar
ln -sf %{_javadir}/javassist.jar javassist.jar
ln -sf %{_javadir}/jboss-aop/jboss-aop-jdk50.jar jboss-aop-jdk50.jar
ln -sf %{_javadir}/jboss-aop/jboss-aspect-library-jdk50-jb32.jar jboss-aspect-library-jdk50-jb32.jar
popd
%endif

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install/jboss-aop.deployer
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install/jboss-aop.deployer/META-INF
install -m 644 output/etc/base-aop.xml $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install/jboss-aop.deployer
pushd $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install/jboss-aop.deployer
ln -sf %{_javadir}/gnu.trove.jar trove.jar
ln -sf %{_javadir}/javassist.jar javassist.jar
ln -sf %{_javadir}/jboss-aop/jboss-aop.jar jboss-aop.jar
ln -sf %{_javadir}/jboss-aop/jboss-aspect-library.jar jboss-aspect-library.jar
popd
cp src/resources/META-INF/jboss-service.xml $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install/jboss-aop.deployer/META-INF

%if %{with_jdk15}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install/jboss-aop-jdk50.deployer
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install/jboss-aop-jdk50.deployer/META-INF
install -m 644 etc/base-aop.xml $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install/jboss-aop-jdk50.deployer
pushd $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install/jboss-aop-jdk50.deployer
ln -sf %{_javadir}/gnu.trove.jar trove.jar
ln -sf %{_javadir}/javassist.jar javassist.jar
ln -sf %{_javadir}/jboss-aop/jboss-aop-jdk50.jar jboss-aop-jdk50.jar
ln -sf %{_javadir}/jboss-aop/jboss-aspect-library-jdk50.jar jboss-aspect-library-jdk50.jar
popd
cp jboss-40-install/jboss-aop-jdk50.deployer/META-INF/jboss-service.xml $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install/jboss-aop-jdk50.deployer/META-INF
cp jboss-40-install/jboss-aop-jdk50.deployer/META-INF/MANIFEST.MF $RPM_BUILD_ROOT%{_datadir}/%{name}/jboss-40-install/jboss-aop-jdk50.deployer/META-INF
%endif

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/lib
pushd $RPM_BUILD_ROOT%{_datadir}/%{name}/lib
ln -sf %{_javadir}/bsh.jar bsh-1.3.0.jar
ln -sf %{_javadir}/concurrent.jar .
ln -sf %{_javadir}/javassist.jar .
ln -sf %{_javadir}/qdox.jar .
ln -sf %{_javadir}/gnu.trove.jar trove.jar
ln -sf %{_javadir}/jboss-aop/jboss-aop.jar .
ln -sf %{_javadir}/jboss-aspects/jboss-aspect-library.jar .
ln -sf %{_javadir}/jboss4/jboss-common.jar .
ln -sf %{_javadir}/jboss-aop/jdk14-pluggable-instrumentor.jar .
popd

%if %{with_jdk15}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/lib-50
pushd $RPM_BUILD_ROOT%{_datadir}/%{name}/lib-50
ln -sf %{_javadir}/bsh.jar bsh-1.3.0.jar
ln -sf %{_javadir}/concurrent.jar .
ln -sf %{_javadir}/javassist.jar .
ln -sf %{_javadir}/qdox.jar .
ln -sf %{_javadir}/gnu.trove.jar trove.jar
ln -sf %{_javadir}/jboss-aop/jboss-aop-jdk50.jar .
ln -sf %{_javadir}/jboss-aop/jboss-aspect-library-jdk50.jar .
ln -sf %{_javadir}/jboss4/jboss-common.jar .
ln -sf %{_javadir}/jboss-aop/pluggable-instrumentor.jar .
popd
%endif

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr output/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi

%files 
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/jboss-aspect-library-%{version}.jar
%{_javadir}/%{name}/jboss-aspect-library.jar
%{_javadir}/%{name}/jboss-aspect-library32-%{version}.jar
%{_javadir}/%{name}/jboss-aspect-library32.jar
%if %{with_jdk15}
%{_javadir}/%{name}/jboss-aspect-library-jdk50-%{version}.jar
%{_javadir}/%{name}/jboss-aspect-library-jdk50.jar
%{_javadir}/%{name}/jboss-aspect-library-jdk50-jb32-%{version}.jar
%{_javadir}/%{name}/jboss-aspect-library-jdk50-jb32.jar
%endif

%{_datadir}/%{name}


%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Wed May 03 2006 Ralph Apel <r.apel at r-apel.de> 0:1.3-1jpp
- First JPP-1.7 release
- Make jdk15 support optional
- Provide/Obsolete jboss-aop-library

